using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Native = Com.Syncfusion.Gauges.SfLinearGauge.SfLinearGauge;

using Xamarin.Forms.Platform.Android;
using System.Reflection;

using Syncfusion.SfGauge.XForms;

[assembly: ExportRenderer(typeof(Syncfusion.SfGauge.XForms.SfLinearGauge), typeof(Syncfusion.SfGauge.XForms.Droid.SfLinearGaugeRenderer))]

namespace Syncfusion.SfGauge.XForms.Droid
{
    public class SfLinearGaugeRenderer : ViewRenderer<Syncfusion.SfGauge.XForms.SfLinearGauge, Com.Syncfusion.Gauges.SfLinearGauge.SfLinearGauge>
    {
        SfLinearGauge gauge;
        public Native nativeGauge;
        public SfLinearGaugeRenderer()
        {

        }
        SfLinearGaugeMapping sfCircularGaugeMapping = new SfLinearGaugeMapping();
        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfGauge.XForms.SfLinearGauge> e)
        {
            base.OnElementChanged(e);
			if (e.NewElement != null) 
			{
				gauge = e.NewElement;
				nativeGauge = new Native (Forms.Context);
				gauge.SizeChanged += gauge_SizeChanged;
				List<string> propertiesNames = GetPropertiesChanged (typeof(SfLinearGauge), gauge);
				foreach (var name in propertiesNames) {
					sfCircularGaugeMapping.OnGaugePropertiesChanged (name, gauge, nativeGauge);
				}

				SetNativeControl (nativeGauge);
				propertiesNames.Clear ();
			}
        }

        void gauge_SizeChanged(object sender, EventArgs e)
        {
            double size = (sender as SfLinearGauge).Width < (sender as SfLinearGauge).Height ? (sender as SfLinearGauge).Width : (sender as SfLinearGauge).Height;
            gauge.HeightRequest = size;
            gauge.WidthRequest = size;
        }
        protected override void OnElementPropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SfLinearGaugeMapping sfCircularGaugeMapping;
            if (sender is SfLinearGauge)
            {
                sfCircularGaugeMapping = new SfLinearGaugeMapping();
                sfCircularGaugeMapping.OnGaugePropertiesChanged(e.PropertyName, gauge, nativeGauge);
            }
        }

        public static List<string> GetPropertiesChanged(Type type, Object obj)
        {
            var properties = type.GetProperties();
            List<string> propertiesList = new List<string>();
            foreach (var item in properties)
            {
                propertiesList.Add(item.Name);
            }
            return propertiesList;
        }
    }
}

