using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using Native = Com.Syncfusion.Gauges.SfLinearGauge;
using Syncfusion.SfGauge.XForms;

namespace Syncfusion.SfGauge.XForms.Droid
{
    public  class LinearHeaderMapping
    {
        #region Properties

		Native.LinearLabel newHeader;
        #endregion

        #region Methods

		public Native.LinearLabel GetHeader(LinearHeader header)
        {
			newHeader = new Native.LinearLabel();
			if (header is LinearHeader)
            {
				List<string> properties = SfLinearGaugeRenderer.GetPropertiesChanged(typeof(LinearHeader), header);
                foreach (var propertyName in properties)
                {
					OnGaugeHeaderPropertiesChanged(propertyName, (LinearHeader)header, (Native.LinearLabel)newHeader);
                }
            }
            return newHeader;
        }

		public void OnGaugeHeaderPropertiesChanged(string propertyName, LinearHeader formHeader, Native.LinearLabel nativeHeader)
        {
            if (propertyName ==LinearHeader.ForegroundColorProperty.PropertyName)
            {
				nativeHeader.TextColor = new global::Android.Graphics.Color() { A = (byte)(formHeader.ForegroundColor.A * 255), R = (byte)(formHeader.ForegroundColor.R * 255), G = (byte)(formHeader.ForegroundColor.G * 255), B = (byte)(formHeader.ForegroundColor.B * 255) };
            }
            else if (propertyName ==LinearHeader.TextProperty.PropertyName)
            {
                nativeHeader.Text = formHeader.Text;
            }
            else if (propertyName ==LinearHeader.PositionProperty.PropertyName)
            {
                nativeHeader.Position = new Android.Graphics.PointF((float)formHeader.Position.X, (float)formHeader.Position.Y);
            }
            else if (propertyName ==LinearHeader.FontProperty.PropertyName)
            {
//                nativeHeader.TextSize = 16;
               // nativeHeader.FontStyle = Android.Graphics.Typeface.Create(formHeader.Font.FontFamily.ToString(), Android.Graphics.TypefaceStyle.Normal);
            }
        }

        #endregion
    }
}