using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Native = Com.Syncfusion.Gauges.SfLinearGauge;
using Syncfusion.SfGauge.XForms;

namespace Syncfusion.SfGauge.XForms.Droid
{
    public  class LinearRangeMapping
    {
		Native.LinearRange newRange;
		public Native.LinearRange GetRange(LinearRange formRange)
        {
			newRange = new Native.LinearRange();
			if (formRange is LinearRange)
            {
				List<string> properties = SfLinearGaugeRenderer.GetPropertiesChanged(typeof(LinearRange), formRange);
                foreach (var propertyName in properties)
                {
					OnRangePropertiesChanged(propertyName, (LinearRange)formRange, (Native.LinearRange)newRange);
                }
            }
            return newRange;
        }

		public void OnRangePropertiesChanged(string propertyName, LinearRange formRange, Native.LinearRange nativeRange)
        {
            if (propertyName ==LinearRange.StartValueProperty.PropertyName)
            {
                nativeRange.StartValue = formRange.StartValue;
            }
            else if (propertyName ==LinearRange.EndValueProperty.PropertyName)
            {
                nativeRange.EndValue = formRange.EndValue;
            }
            else if (propertyName ==LinearRange.ColorProperty.PropertyName)
            {
                nativeRange.Color = new global::Android.Graphics.Color() { A = (byte)(formRange.Color.A * 255), R = (byte)(formRange.Color.R * 255), G = (byte)(formRange.Color.G * 255), B = (byte)(formRange.Color.B * 255) };
            }

            else if (propertyName ==LinearRange.OffsetProperty.PropertyName)
            {
				nativeRange.Offset = formRange.Offset - 0.04;
            }
            else if (propertyName ==LinearRange.StartWidthProperty.PropertyName)
            {
                nativeRange.StartWidth = formRange.StartWidth*2;
            }
            else if (propertyName ==LinearRange.EndWidthProperty.PropertyName)
            {
                nativeRange.EndWidth = formRange.EndWidth*2;
            }
        }
    }
}