using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using Native = Com.Syncfusion.Gauges.SfLinearGauge.LinearTickSettings;

namespace Syncfusion.SfGauge.XForms.Droid
{
    public class LinearTicksMapping
    {
		public LinearTicksMapping()
        {
        }
        public Native GetTicks(LinearTickSettings formTicks)
        {
            Native newTicks = new Native();
			if (formTicks is LinearTickSettings)
            {
				List<string> properties = SfLinearGaugeRenderer.GetPropertiesChanged(typeof(LinearTickSettings), formTicks);
                foreach (var propertyName in properties)
                {
					OnPointerPropertiesChanged(propertyName, (LinearTickSettings)formTicks, (Native)newTicks);
                }
            }
            return newTicks;
        }

		public void OnPointerPropertiesChanged(string propertyName, LinearTickSettings formTicks, Native nativeTicks)
        {
            if (propertyName == LinearTickSettings.LengthProperty.PropertyName)
            {
				nativeTicks.Length = formTicks.Length;
            }
            else if (propertyName == LinearTickSettings.ColorProperty.PropertyName)
            {
                nativeTicks.Color = new global::Android.Graphics.Color() { A = (byte)(formTicks.Color.A * 255), R = (byte)(formTicks.Color.R * 255), G = (byte)(formTicks.Color.G * 255), B = (byte)(formTicks.Color.B * 255) };
            }
            else if (propertyName == LinearTickSettings.ThicknessProperty.PropertyName)
            {
				nativeTicks.StrokeWidth = formTicks.Thickness;
            }
            else if (propertyName == LinearTickSettings.OffsetProperty.PropertyName)
            {
				nativeTicks.Offset = formTicks.Offset;
            }
        }
    }
}