﻿using System;

using Syncfusion.SfGauge.XForms;
using Xamarin.Forms;

namespace SyncFusionTestBench
{
	public class CosPhiGauge: SfCircularGauge
	{
		public CosPhiGauge()
		{
			this.BackgroundColor = Color.White;
			this.HeightRequest = 300;
			this.HorizontalOptions = LayoutOptions.CenterAndExpand;
			this.VerticalOptions = LayoutOptions.FillAndExpand;

			var scale = new Scale()
			{
				StartValue = 0,
				EndValue = 10,
				StartAngle = 135,
				SweepAngle = 270,
				RimThickness = 50,
				Interval=1, 
				RimColor = Color.FromHex("#EAE9E9"),
				LabelColor = Color.Gray,
				LabelOffset = 0.2,
				MinorTicksPerInterval = 5,
				MajorTickSettings = new TickSettings { Length = 20, Color = Color.Black, Thickness = 5 },
				MinorTickSettings = new TickSettings { Length = 5, Color = Color.Black, Thickness = 3, Offset = 0.1 },
			};


			var needle = new NeedlePointer()
			{
				Color = Color.Aqua,
				Thickness = 5,
				KnobRadius = 15, KnobColor=Color.Gray,
				Value = 0.95,
				LengthFactor = 0.8,
			};

            Header hLabel = new Header()
            {
                Text = "Cos Phi",
                TextSize = 20,
                ForegroundColor = Color.Black,
                Position = new Point(0.0, 0.9),
            };
            this.Headers.Add(hLabel);

            Header hValue = new Header()
            {
                Text = "0.95",
                TextSize = 20,
                ForegroundColor = Color.Gray,
                Position = new Point(0.30, 0.8),
            };
            this.Headers.Add(hValue);

            scale.Pointers.Add(needle);
			this.Scales.Add(scale);
		}
	}
}

